﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel.DataAnnotations;
using System.Collections.Generic;

namespace HidingTotalsOnLayoutLoaded.WPF
{
    public class CarsSales
    {

        private static String[] SellerNames = new[] { "Alex", "Bill", "Bill", "Alex","Bill", "Kate", "Jason", "John", "John", "Maria", "John" };
        private static String[] Countries = new[] {"Italy","Germany","Germany","Belgium","US","Italy","US","Italy","US","France","Argentina" };
        private static String[] Cities = new[] { "Milano","Düsseldorf","Berlin","Brussel","Boston","Milano","Boston","Milano","Boston","Paris","Buenos Aires" };
        private static int[] unit = new[] { 1,1,2,3,2,4,2,1,1,1,2 };
        private static double[] cost = new[] { 1500.0, 2000.0, 2200.0, 5200.0, 4000.0, 3100.0, 15100.0, 7100.0, 8900.0, 4900.0, 3400.0 };
        private static double[] internetcost = new[] { 1700.0, 2300.0, 2800.0, 5500.0, 4500.0, 4100.0, 15600.0, 7500.0, 9300.0, 5600.0, 4400.0 };
        private static DateTime[] salesDate = new[] { new DateTime(2009, 12, 03), new DateTime(2010, 11, 12), new DateTime(2007, 07, 15), new DateTime(2010, 11, 03), new DateTime(2006, 06, 12), new DateTime(2008, 02, 07), new DateTime(2007, 08, 14), new DateTime(2009, 07, 01), new DateTime(2007, 06, 23), new DateTime(2010, 10, 03), new DateTime(2009, 10, 13) };

        //cars
        private static String[] brand = new[] { "Peugeot", "Peugeot", "Peugeot", "Peugeot", "Peugeot", "Ford", "Mercedes", "Citroen", "Citroen", "Citroen", "Seat" };
        private static String[] model = new[] { "206", "206", "306", "206","206", "KA", "Benz", "C3", "C2", "C4", "Toledo" };
        private static String[] modification = new[] { "XS", "XS", "XS", "SW","SW", "", "", "", "", "", "" };
        private static int[] year = new[] { 1998, 1999, 2001, 2006, 2006, 2002, 2002, 2005, 2001, 2007, 2008 };

        //sales territory
        private static String[] continents = new[] { "Europe", "Europe", "Europe", "Europe","Europe","North America", "North America", "North America", "North America", "Australia", "South America", "Asia", "Africa" };
        private static String[] countries = new[] { "Bulgaria", "Germany", "Italy", "France","Bulgaria", "US", "Canada", "Canada", "Canada", "Australia", "Argentina","China","Egypt" };
        private static String[] cities = new[] { "Sofia", "Berlin", "Rome", "Paris","Plovdiv", "New York", "Toronto", "Vancouver", "Vancouver", "Sidney", "Buenos Aires", "Shanghai","Kairo" };


        //[DisplayFormat(DataFormatString = "{0:####}")]
        [Display(Name = "Units1")]
        public int Units
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:C}")]
        public double Cost
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:C}")]
        public double InternetCost
        {
            get;
            set;
        }

        public DateTime SalesDate
        {
            get;
            set;
        }

        [DisplayAttribute(Name = "Sales Person", Description = "The names of the sales person.")]
        public string Seller
        {
            get;
            set;
        }

        [DisplayAttribute(Name = "Sales Territory")]
        public SalesTerritory SalesTerritory
        {
            get;
            set;
        }

        [DisplayAttribute(Name = "OriginalCountry")]
        public string OriginalCountry
        {
            get;
            set;
        }

        [DisplayAttribute(Name = "OriginalCity")]
        public string OriginalCity
        {
            get;
            set;
        }

        [DisplayAttribute(Name = "Cars")]
        public Car Car
        {
            get;
            set;
        }


        public static List<Car> GenerateCars()
        {
            List<Car> Cars = new List<Car>();

            for (int i = 0; i < 11; i++)
            {
                Car car = new Car();
                car.Brand = brand[i];
                car.Model = model[i];
                car.Modification = modification[i];
                car.Year = year[i];
                Cars.Add(car);
            }

            return Cars;
        }

        public static List<SalesTerritory> GenerateSalesTerritory()
        {
            List<SalesTerritory> salesTerritory = new List<SalesTerritory>();

            for (int i = 0; i < 13; i++)
            {
                SalesTerritory teritorry = new SalesTerritory();
                teritorry.Continent = continents[i];
                teritorry.Country = countries[i];
                teritorry.City = cities[i];

                salesTerritory.Add(teritorry);
            }

            return salesTerritory;
        }

        public static IEnumerable<CarsSales> GenerateData()
        {                 
            List<CarsSales> CarsSales = new List<CarsSales>();
            List<Car> cars = GenerateCars();
            List<SalesTerritory> salesTerritory = GenerateSalesTerritory();

            for (int i = 0; i < 11; i++)
            {
                CarsSales carSale = new CarsSales();
                carSale.Seller = SellerNames[i];
                carSale.OriginalCountry = Countries[i];
                carSale.OriginalCity = Cities[i];
                           
                carSale.Cost = cost[i];
                carSale.Units = unit[i];
                carSale.InternetCost = internetcost[i];
                carSale.SalesDate = salesDate[i];
                carSale.Car = cars[i];
                carSale.SalesTerritory = salesTerritory[i];
                CarsSales.Add(carSale);
            }

            //CarsSales tempCar1 = new CarsSales();
            //tempCar1.SalesTerritory = salesTerritory[11];
            //CarsSales.Add(tempCar1);

            //CarsSales tempCar2 = new CarsSales();
            //tempCar2.SalesTerritory = salesTerritory[12];
            //CarsSales.Add(tempCar2);

            return CarsSales;
        }

    }
}
